/*
 * gps_sirf.h
 *
 *  Created on: Jul 12, 2010
 *      Author: rohit
 *
 * University of Minnesota 
 * Aerospace Engineering and Mechanics 
 *  2011 Regents of the University of Minnesota. All rights reserved.
 * $Id: gps_sirf.h 253 2011-01-20 22:01:35Z murch $
 */

#ifndef GPS_SIRF_H_
#define GPS_SIRF_H_


#define		int8_t			char
#define		uint8_t			unsigned char
#define		uint16_t		unsigned short
#define 	uint32_t		unsigned int
#define		int32_t			int
#define		int64_t			long int
#define		uint64_t		unsigned long int

//#define verbose

/* these are independent of byte order */
#define getsb(buf, off)	((int8_t)buf[(off)])
#define getub(buf, off)	((uint8_t)buf[(off)])

/* SiRF and most other GPS protocols use big-endian (network byte order) */
#define getbesw(buf, off)	((int16_t)(((uint16_t)getub(buf, (off)) << 8) | (uint16_t)getub(buf, (off)+1)))
#define getbeuw(buf, off)	((uint16_t)(((uint16_t)getub(buf, (off)) << 8) | (uint16_t)getub(buf, (off)+1)))
#define getbesl(buf, off)	((int32_t)(((uint16_t)getbeuw(buf, (off)) << 16) | getbeuw(buf, (off)+2)))
#define getbeul(buf, off)	((uint32_t)(((uint16_t)getbeuw(buf, (off)) << 16) | getbeuw(buf, (off)+2)))
#define getbesL(buf, off)	((int64_t)(((uint64_t)getbeul(buf, (off)) << 32) | getbeul(buf, (off)+4)))
#define getbeuL(buf, off)	((uint64_t)(((uint64_t)getbeul(buf, (off)) << 32) | getbeul(buf, (off)+4)))
/* float and double */
#define getbef(buf, off)	(i_f.i = getbesl(buf, off), i_f.f)
#define getbed(buf, off)	(l_d.l = getbesL(buf, off), l_d.d)


//----------------------function prototypes------------------------------------
int init_gps(char *portname, int baudrate);
void nmea_add_checksum(unsigned char *sentence);
int getSerialSpeed(int port);
int RxSirfPacket( int port, struct gps *pckt, unsigned int bytesinbuffer );
int verifySirfCksum(byte *buf, int packetsize);
int read_gps(struct gps *gpspkt, int port);
void parseSirfPacket( byte *b, struct gps *pckt );
//-----------------------------------------------------------------------------

// serial port buffer handle
cyg_io_handle_t ttl0_handle;
cyg_serial_buf_info_t buff_info;
unsigned int len = sizeof (buff_info);



#endif /* GPS_SIRF_H_ */
